<?php
App::uses('Component', 'Controller');

class BuzzWaiversComponent extends Component {

	protected $_controller = null;

	public $kioskMode = false;

	public $participant = null;
	public $booking = null;
	public $id = null;

    /**
     * Sets a reference to the calling controller from within the component.
     *
     * @see Component::initialize()
     */
    public function initialize(Controller $controller) {
        parent::initialize($controller);
        $this->_controller = $controller;


		if ($this->_controller->request->params['action'] == 'stage') {

			if (! empty($this->_controller->request->params['kiosk'])) {
				$this->kioskMode = true;

				$this->_controller->layout = 'BuzzWaivers.Kiosk';
			}

			if (! empty($this->_controller->request->params['pass'][1])) {
				$this->id = $this->_controller->request->params['pass'][1];

				$this->loadParticipant();
			}
		}
    }

	public function loadParticipant() {
		$this->_controller->loadModel('BuzzWaivers.Participant');
		$this->_controller->loadModel('BuzzWaivers.WaiversApi');
		$this->participant = $this->_controller->Participant->find('first', array(
			'conditions' => array(
				'id' => $this->id
			),
			'contain' => array(
				'Condition'
			)
		));

		if (empty($this->participant)) {
			throw new NotFoundException();
		}

		$this->booking = $this->_controller->WaiversApi->getBooking(
			'Participant',
			$this->participant['Participant']['id'],
			$this->participant['Participant']['sales_ref'], $this->participant['Participant']['booking_date']);

		$this->_controller->set('participant', $this->participant);
		$this->_controller->set('booking', $this->booking);

		if ($this->participant['Participant']['waiver_complete'] == '1') {
			return false;
		}

		return true;
	}

	public function saveParticipant() {

		$this->_controller->loadModel('BuzzWaivers.Participant');
		$this->_controller->Participant->save($this->participant['Participant'], false);

		$this->loadParticipant();
	}

}
